//! Arbitrarily large integers
//!
//! Traits to implement:
//! * Add
//! * AddAssign
//! * Div
//! * DivAssign
//! * Mul
//! * MulAssign
//! * Neg
//! * Rem
//! * RemAssign
//! * Sub
//! * SubAssign
use crate::{Sign, Unsigned};

#[derive(Debug)]
pub struct BigInt {
    inner: Vec<usize>,
    sign: Sign,
}

impl Default for BigInt {
    fn default() -> Self {
        Self {
            inner: vec![],
            sign: Sign::Positive,
        }
    }
}

impl<T: Unsigned> From<T> for BigInt {
    fn from(n: T) -> Self {
        let mut new = Self::default();

        if n > T::max_value() {
            new.inner = BigInt::split(n);
        }

        new
    }
}

impl BigInt {
    /// Split an unsigned number into BigInt parts
    fn split<T: Unsigned>(num: T) -> Vec<usize> {
        // Pretty easy if you don't actually need to split the value!
        if num < T::max_value() {
            return vec![T::into()];
        }

        todo!();
    }
}

impl BigInt {
    pub fn new() -> Self {
        Self::default()
    }
}

#[cfg(test)]
mod tests {

}